<?php
/* $Id: db_create.sqlite.php 149 2011-03-22 00:18:30Z mir $ */

function make_sql_stm() {
    $db = array();

    array_push($db, "drop table if exists roles");
    array_push($db, "CREATE TABLE roles (
    id integer primary key autoincrement,
    name text not null
    )");
    array_push($db, "INSERT INTO roles VALUES(0,'administrator')");
    array_push($db, "INSERT INTO roles VALUES(1,'power user')");
    array_push($db, "INSERT INTO roles VALUES(2,'user')");

    array_push($db, "drop table if exists user");
    array_push($db, "CREATE TABLE user (
    id integer primary key autoincrement,
    uid text not null,
    pwd text not null,
    userrole integer not null,
    timeout integer default 3600,
    userview text default 'week',
    weekstart integer default 0,
    daystart real default 8.00,
    dayend real default 17.00,
    timezone text default 'Etc/UTC',
    seckey text default '',
    pubkey text default '',
    constraint uid_index unique (uid)
    )");

    array_push($db, "drop table if exists calendar");
    array_push($db, "CREATE TABLE calendar (
    id integer default -1,
    uid integer not null,
    name text not null,
    color text default 'navy',
    config text default '',
    constraint calendar_pk primary key (id, uid)
    )");
    array_push($db, "CREATE TRIGGER compute_id after insert on calendar
    begin
        update calendar set id = (select max(id) + 1 from calendar) where id = -1;
    end;");
    array_push($db, "CREATE TRIGGER genfkey2_insert_referencing BEFORE INSERT ON calendar WHEN
        new.uid IS NOT NULL AND NOT EXISTS (SELECT 1 FROM user WHERE new.uid == id)
    BEGIN
      SELECT RAISE(ABORT, 'constraint failed');
    END");
    array_push($db, "CREATE TRIGGER genfkey2_update_referencing BEFORE
        UPDATE OF uid ON calendar WHEN
        new.uid IS NOT NULL AND
        NOT EXISTS (SELECT 1 FROM user WHERE new.uid == id)
    BEGIN
      SELECT RAISE(ABORT, 'constraint failed');
    END");
    array_push($db, "CREATE TRIGGER genfkey2_delete_referenced BEFORE DELETE ON
    user WHEN EXISTS (SELECT 1 FROM calendar WHERE old.id == uid)
    BEGIN
      DELETE FROM calendar WHERE uid = old.id;
    END");
    array_push($db, "CREATE TRIGGER genfkey2_update_referenced AFTER
        UPDATE OF id ON user WHEN
        EXISTS (SELECT 1 FROM calendar WHERE old.id == uid)
    BEGIN
      UPDATE calendar SET uid = new.id WHERE uid = old.id;
    END");
    array_push($db, "CREATE TRIGGER genfkey1_insert_referencing BEFORE INSERT ON
    user WHEN new.userrole IS NOT NULL AND NOT EXISTS (SELECT 1 FROM roles WHERE
    new.userrole == id)
    BEGIN
      SELECT RAISE(ABORT, 'constraint failed');
    END");
    array_push($db, "CREATE TRIGGER genfkey1_update_referencing BEFORE
        UPDATE OF userrole ON user WHEN new.userrole IS NOT NULL AND
        NOT EXISTS (SELECT 1 FROM roles WHERE new.userrole == id)
    BEGIN
      SELECT RAISE(ABORT, 'constraint failed');
    END");
    array_push($db, "CREATE TRIGGER genfkey1_delete_referenced BEFORE DELETE ON
    roles WHEN EXISTS (SELECT 1 FROM user WHERE old.id == userrole)
    BEGIN
      SELECT RAISE(ABORT, 'constraint failed');
    END");
    array_push($db, "CREATE TRIGGER genfkey1_update_referenced AFTER
        UPDATE OF id ON roles WHEN
        EXISTS (SELECT 1 FROM user WHERE old.id == userrole)
    BEGIN
      UPDATE user SET userrole = new.id WHERE userrole = old.id;
    END");
    array_push($db, "drop table if exists about");
    array_push($db, "create table about (
    id integer default 1,
    version text default '')");
    array_push($db, "drop table if exists ldap");
    array_push($db, "create table ldap (
    enable integer default 0,
    dns text default '',
    tls integer default 0,
    base_dn text default '',
    user_attr text default 'uid')");

    return $db;
}
